package Zaphod::Editor::Attic;

=head1 NAME

Zaphod::Editor::Attic - dead stuff

=cut

use vars qw($VERSION);
$VERSION = '0.02';

sub delete_char_left  :Action {
    my ($self, $chars) = @_;

    # Should ensure that the line exists, and if
    # not, auto-extend the document

    $self->move_cursor_horizontal(-length $chars);
    $self->delete_char_right($chars);

    1;
};

sub delete_char_right :Action {
    my ($self, $chars) = @_;

    my ($c) = $self->cursor_column;

    # Should ensure that the line exists, and if
    # not, auto-extend the document

    substr( $self->current_line, $c, length $chars) = '';

    1;
};

sub insert_char_right :Action {
    my ($self, $chars) = @_;

    my ($c) = $self->cursor_column;

    # Should ensure that the line exists, and if
    # not, auto-extend the document

    substr($self->current_line,$c,0) = $chars;
    $self->move_cursor_horizontal(length $chars);

    1;
};

sub insert_char_left :Action {
    my ($self, $chars) = @_;

    my ($l,$c) = $self->cursor_pos;

    # Should ensure that the line exists, and if
    # not, auto-extend the document

    substr($self->document->[$l],$c,0) = $chars;

    1;
};

# Install some aliases
# This weirdly needs to be delayed, as seemingly,
# the aliases aren't bound in the way I expect them
CHECK {
    eval "*insert_char = \&insert_char_right";
};


=head1 AUTHOR

Written by Max Maischein E<lt>corion@cpan.orgE<gt>

Copyright Max Maischein 2005,2006; All Rights Reserved.

This program is free software; you can redistribute it
and/or modify it under the same terms as Perl itself.

=head1 SEE ALSO

L<Zaphod>

=cut
