package Zaphod::Session::Response;
use strict;
use base 'Class::Accessor';

=head1 NAME

Zaphod::Session::Response - encapsulate a response from the server

=cut

use vars qw($VERSION);
$VERSION = '0.02';

__PACKAGE__->mk_accessors(qw( changes delay users
  timestamp state cookie user session
  document code
));

sub new {
    my ($package) = shift;
    my $self = $package->SUPER::new(@_);
    if (! $self->timestamp) {
        $self->timestamp(time());
    };
    $self
}

1;